#include "joystick.h"

joystick::joystick(const string& dev,int flags)
{

  int num_axis=0, num_buttons=0;
  char name_joystick[80];

  if((fd = open(dev.c_str(),flags)) == -1)
  {
    //TODO: error code here
  }

  ioctl( fd, JSIOCGAXES, &num_axis );
  ioctl( fd, JSIOCGBUTTONS, &num_buttons );
  ioctl( fd, JSIOCGNAME(80), &name_joystick );
  axis.resize(num_axis,0);
  buttons.resize(num_buttons,0);
  joystick_name = name_joystick;
}

joystick::~joystick()
{
  close(fd);
}

vector<int> joystick::getAxis()
{
  return axis;
}

vector<int> joystick::getButtons()
{
  return buttons;
}

int joystick::getAxis(const int& a)
{
  if(a < 0 || a >= axis.size())
  {
    //TODO: error code here
  }
  return axis[a];
}

int joystick::getButton(const int& b)
{
  if(b < 0 || b >= axis.size())
  {
    //TODO: error code here
  }
  return buttons[b];
}

int joystick::run()
{
  int pid;
  if(!(pid = fork()))
  {
    for EVER
    {
      struct js_event js;
      int pid2;
      read(fd,&js,sizeof(struct js_event));
      if(!(pid2 = fork()))
      {
        for(vector<listener*>::iterator i = jsl.begin();
            i != jsl.end(); i++)
        {
          (*i)->actionPerformed(&js,this);
        }       
        _exit(0);
      }
    }
    _exit(0);
  }
  return pid;
}

void joystick::addListener(listener* l)
{
  jsl.push_back(l);
}

void joystick::setAxis(const int& a,const int& val)
{
  axis[a] = val;
}

void joystick::setButton(const int& b,const int& val)
{
  buttons[b] = val;
}
